boundsGen <- function(y, alpha, qA){
  if(missing(qA)){
    bou <- stepR::bounds(y, penalty = "sqrt", alpha = alpha)$bounds
  }else{
    bou <- stepR::bounds(y, penalty = "sqrt", q = qA)$bounds
  }

  bou[,3:4] <- .Call('boundsgen', c(bou[ ,1], bou[ ,2], bou[ ,3], bou[ ,4] ), as.integer( dim( bou )[1] ) )
  remove <- which( bou[,3] > bou[,4] )
  if(length( remove ) > 0){
    bou <- bou[-remove,]
  }  
  return(bou)
}
