#include <algorithm>
#include <R.h>
#include <Rinternals.h>

using namespace std;

extern "C"{
	SEXP boundsgen(SEXP bounds, SEXP size){
		double* rbounds = REAL(bounds);
		int rsize = *INTEGER(size);
		SEXP boundsout;
	    PROTECT(boundsout = allocVector(REALSXP, rsize*2));
	    double* rboundsout = REAL(boundsout);
		

		for(int i = 0; i < rsize; i++){
			rboundsout[i] = rbounds[i + 2*rsize];
			rboundsout[i+rsize] = rbounds[i + 3*rsize];
			for(int j = 0; j< rsize; j++){
				if(rbounds[j] >= rbounds[i] && rbounds[j+ rsize] <= rbounds[i + rsize]){
					rboundsout[i] = max(rboundsout[i], rbounds[j + 2*rsize]);
					rboundsout[i + rsize] = min(rboundsout[i + rsize], rbounds[j+3*rsize]);
				}
			}

		}
	UNPROTECT(1);
	return(boundsout);
	}
}


