#include <vector>
#include <typeinfo>
#include <R.h>
#include <Rinternals.h>

using namespace std;


extern "C"{
	SEXP maxel (SEXP bou){
		double* rbou = REAL(bou);
		int sizeb = length(bou) / 2;

		SEXP me;
		PROTECT(me = allocVector(INTSXP, sizeb));
		int* rme = INTEGER(me);

		for(int i = 0; i < sizeb; i++){
			rme[i] = 1;
		}

		for(int i = 0; i < sizeb ; i++){
			if(rme[i] != 0){
				for( int j = 0; j < sizeb; j++){
					if(i != j){
					if(rbou[ i*2 ] >= rbou[j*2] && rbou[i*2 +1] <= rbou[j * 2 + 1]){
						rme[i] = 0;
						break;
					}
					if(rbou[ i*2 ] <= rbou[j*2] && rbou[i*2 +1] >= rbou[j * 2 + 1]){
						rme[j] = 0;
					}
					}
				}
			}
		} 


		UNPROTECT(1);
	    return(me);
	}
}
